
#define Version "2022_0726"
#define With_GT38
 // usage de UART1 9600 -> GT38 
 // et UART3 9600 -> suivi ,debugging
 
 // GT38 Rose cot  PIC 12F1840 + DS18B20 OWS  + UART3   -> terminal YAT 9600bds
 
 // 
 /* GT38 Vert cot Terminal YAT 9600 bds
   Mettre SET=0 pour etre en  mode AT
   AT
   OK
   AT+V
   guoyunkeji?GT-38 https://shop532831232.taobao.com
   AT+RX
   OK+B9600
   OK+C014
   OK+RP:-1dBm
   OK+FU3
   puis SET=1
   */

/*
(10:19:16.877) AT
(10:19:17.143)  OK
(10:19:28.924) AT+V
(10:19:29.096) (10:19:29.096)  guoyunkeji GT-38
(10:19:29.127)  https://shop532831232.taobao.com
(10:19:36.611) AT+RX
(10:19:36.783)  OK+B9600
(10:19:36.799)  OK+C002
(10:19:36.814)  OK+RP:-1dBm
(10:19:36.830)  OK+FU3
*/


//#define Version "190715"
// rajout commande choix puissance  distance PU=x  avec  x de 1  8   => commande AT+P1  AT+P8
// porte maxi 25M  travers 2 murs et 1 cloison
// PIC12F1840 Dip8 + GT38
// envoi chaque sec  valeur de l'indice 0  65535 + mesures capteur DS18B20
// si reception par GT38 distant , analyse la commande recue et reagit
// ex de cde distance LED=1 ou LED=0 , concerne la led sur RA0 du PIC12F
// mode P8 maxi activ  et FU04 1200 bauds
// conso moyenne 25mA
// et 11mA en mode AT ( pin SET du HC08 au 0V)
// revient  25mA en laissant SET  1 ( en l'air , pullup interne
// MCU presque FULL en RAM !!!!!!!!!!!!!!!!!!!!!!!!!
//  Used RAM (bytes): 237 (99%)  Free RAM (bytes): 3 (1%)
// Used ROM (program words): 2269 (55%)  Free ROM (program words): 1827 (45%)
// 9600 bauds maxi avec GT38   en mode FU3
// 1200 bauds en mode FU4

/*

   horloge  :  interne  16 MHz ... pas de quartz
   Librairies utilisees :
   - built_in.h
   - UART
   - C_String
   - Conversions
   - ADC

 */

  /* Hardware
  12F1840
  pin 1     VDD Alim +5V
  pin 2     RA5  input RX ---- <---- Pin 4  GT38 TX
  pin 3     RA4  output TX ---->---- Pin 3  GT38 TX
  pin 4     RA3/MCLR/VPP -- ICSP Reset
  pin 5     RA2  input <--- OWS DS18B20
  pin 6     RA1 ICSP Clock & Output -> Pin 5  -------> GT38 SET input
  pin 7     RAO  ICSPDAT   & Output -> R2,7K---------- Led-- 0V
  pin 7     RAO  Output   ---- UART3 TX   ----> RX Terminal YAT 19200 bds
  pin 8     VSS alim 0V
  */
   //     ac:schema
   
    //

#include "built_in.h"     // for  Hi  Lo ..etc
#define With_UART3       // pour traage programme
  
#define TAB 9
#define CLS 12
#define CR 13
#define LF 10

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_12F1840_GT38_test_Transceivers_2022_07"
#define Projet "_12F1840_GT38_test_Transceivers_2022_07.mcppi"
#define Source "_12F1840_GT38_test_Transceivers_"      // sans date ni  extension !
#define Langage "MikroC 7.6.0"
#define Config "P12F1840_Fosc_Interne_16MHz.cfgsch"
//CONFIG1 : $8007 : 0x0984
//CONFIG2 : $8008 : 0x3413

#define MCU "12F1840 DIP8"
#define POWER_SUPPLY "3,6V  4.5V"    // (3,3 to 4,2V battery Li-IOn)
#define OSCILLATEUR_INTERNE
#define FOSC "16MHZ"
#define EEPROM_FILE "xxx_Eeprom.ihex"


#define GT38_CANAL "14"
#define GT38_MODE "FU3"
#define UART1_BAUDS 9600       // UART1
#define GT38_BAUDS "9600"
#define GT38_PUISSANCE "P1"     // + 1dbm

#define OWS_Pin  &PORTA,2
sbit GT38_Set_Pin at LATA.B1;
sbit GT38_Set_Pin_Dir at TRISA.B1;



//************  UART 3 en ASM *********************************
#define SPEED 56  // at 9600  104S/bit  at 16MHz
//#define SPEED 28    //  at 19200 52S / bit at 16Mhz
// la Pin de sortie UART est definie dans le main program
sbit TX3_Pin at LATA.B0;
sbit TX3_Pin_Dir at TRISA.B0;
unsigned char c3 absolute 0x0020;
unsigned char RS_Count absolute 0x0021;
unsigned char  RS_tmp absolute 0x0022;
unsigned char RS_Delay absolute 0x0023;

//**************************************************************

const code char mesg0[]="                    "; // 20 blancs pour effacer la ligne LCD
const code char mesg1[]=" Compilateur : "Langage"\n\r";
const code char mesg2[]=" Directory :"Directory"\r\n";
const code char mesg3[]=" Projet    :"Projet"\r\n";
const code char mesg4[]=" Source    :"Source"_"Version"\r\n";
const code char mesg5[]=" MCU  :"MCU" , Config: "Config"\r\n";
const code char mesg6[]=" POWER_SUPPLY: "POWER_SUPPLY"\r\n ATTENTION! Pin 1 =VDD pin 8=Gnd\r\n";
const code char mesg7[]=" Capteur OWS DS18B20 sur RA2(pin5) \r\n GT38 SET sur RA1(pin6)\r\n";
const code char mesg8[]=" GT38 mode"GT38_MODE"\r\n UART1 <-> GT38 "GT38_BAUDS",8,N,1  pin2=RA5=RX  Pin3=RA4=Tx\r\n";
//const code char mesg9[]=" Avec (only) TX UART3 19200 bds (en ASM !) sur RA0 (Pin 7) output\r\n";
const code char mesg9[]=" Avec (only) TX UART3 9600 bds (en ASM !) sur RA0 (Pin 7) output\r\n";

//const code char mesg9[]=" Pin 7 RA0=Led Rouge r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9}; //,mesg9};

//const unsigned short TEMP_RESOLUTION = 12;



#define MAXLEN1 40
char buffer1[MAXLEN1];
unsigned short error;
volatile unsigned int CptErr;
volatile unsigned int Count;
static int Flag_Timer1;
volatile int   DataReady1 =0;      // drapeau Data recue;
volatile int NB;
volatile int Index1, i1;
volatile  unsigned char c1, cx;
volatile int j;
unsigned int i,k;
//unsigned M;
char *p1;
char TEXTE[40];//  ="12F1840_Usart_Interrupt_Timer1";
char *txt;
char CRam1[16];
unsigned int Mode_Sleep;
char Recu=0;

volatile unsigned int Count1;

unsigned int temp=0;
//unsigned long  DS18B20_Temp1=0L;
//unsigned char TH1,TL1,AL1;
//unsigned char ID1[6];


#ifdef With_UART3
void UART3_Write(unsigned char c1);         // ecrit 1 char
void UART3_Write_Text(unsigned char *T);    // ecrit un texte situ en RAM
void UART3_Write_CText(const char *txt3);    // ecrit un texte en dur (situ en ROM)
void CRLF3(void) ;
#endif


void strConstRamCpy(char *dest, const char *source);
void Write_String(char * texte);
void CRLF1(void);
void Tempo(unsigned long L);
void Arme_Timer1(unsigned int N);
char  DS18B20_Build_value(unsigned int temp2write, char * T);

#ifdef With_UART3
void UART3_Write_CText(const char *txt3)
 {
   while (*txt3)
     {
     UART3_Write(*txt3++);
  //  Delay_us(500);
     }
}

void UART3_Write_Text(unsigned char *T)    // at adress  0x002 taille 42 bytes
{
  while(*(T)>0)     // verif sur VBRAY en mode ASCII
   {
    UART3_Write(*(T++));   // c3 variable globale
   //  Delay_us(500);
   }
}

void CRLF3()
{
 UART3_Write(CR);
 UART3_Write(LF);
}


void UART3_Write(unsigned char cc)      // 16MHz 19200 ou 9600 bauds
{
    c3=~cc;    // complement du caractere !
    // avec TX3_PIN => RA2  18F26K22
        // avec TX3_PIN => RA0 12F1840
  _asm{
    RSsend2:
        movlw   8               ; 8 bits
        movwf   _RS_Count       ; compteur de bits envoyes
        bcf     TX3_Pin         ; was LATA,2    bit de start
        call    RSdelai2        ; tempo
       //   rrf        _c1,f    ; on recupere dans C le bit à envoyer
       //  syntaxe a revoir en fonction du PIC utilise  rrcf avec 18F87J50
       //                                                rrf avec PIC12F1840
    L00:
        rrf    _c3,1                ; on recupere dans C le bit a envoyer
        btfsc   STATUS,C        ; bit a envoyer = 1 ?
        goto    L10             ; oui
        bsf     TX3_Pin                        ; was LATA,2     sinon 0
        goto    L20             ; on continue sur la tempo
    L10:
        bcf     TX3_Pin                        ; was LATA,2  bit a 1
    L20:
        call    RSdelai2                ; tempo
        decfsz  _RS_Count,1     ; on decremente le compteur de bits envoyés
        goto    L00             ; on continue sur les bits suivants
        bsf     TX3_Pin         ; was  LATA,2 ; bit de stop
        call    RSdelai2        ; tempo pour bit de stop
         call    RSdelai2       ; tempo pour bit de stop
        goto    LA1

    RSdelai2:                 // 52 S par bit at 19200 bauds  104S at 9600 bds

         MOVLW SPEED ;  //  at 9600   104S
         MOVWF _RS_tmp ;
    RS00:
         NOP;                ; fait parti de la tempo!
         NOP;
         NOP;
         NOP;
        // NOP;
         DECFSZ _RS_tmp,F ;
         GOTO   RS00 ;
         NOP;
         NOP;
         NOP;
         RETURN ;

    LA1:    nop;
   }
 }
 #endif


void Interrupts() iv 0x0004 ics ICS_AUTO {

 if ( (RCIE_bit==1)&& (RCIF_bit==1))
   {
    c1 = UART1_Read();
   // c1 =RCREG;
    if (c1==10) c1=0;
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       TXREG=c1;     // echo of receiveid char
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      CptErr++;
      RCSTA.SPEN= 1 ;
       c1 = RCREG;
      }
      // stop sur maxima bytes ou timeout
    //    if(  ( Flag_Timer1==1) || (i1>NB) )
       if( ( c1==13) || (i1>NB) )
        {
           RCIE_bit=0 ; //interdit IT Reception UART
           DataReady1 = 1;
            buffer1[i1]=0;
            Index1=i1;
            Delay_ms(100);
           if(RCIF_bit==1) c1=RCREG;
            i1=0;
            c1=0;
            }
            else
            {
            buffer1[i1]=c1;
            Index1=i1;
            i1++;
         }

   }

      // timer 1
    if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {
      Count1--;
      // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     if (Count1<1)   // x 100mS
       {
        Count1=0;
        Flag_Timer1=1;
        TMR1IE_bit=0;
      }
      TMR1H         = 0x3C;
      TMR1L         = 0xB0;
      PIR1.TMR1IF=0;

   }


 }

void Write_String(char * texte)
{
while (* texte)
 {
  UART_Write(* texte++);
 }
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART_Write(CR);
 UART_Write(LF);
}
void UART1_Write_CText(const char *txt1) {
   while (*txt1)
      UART1_Write(*txt1++);
      Delay_ms(1);

}

void Raz_Buffer1()
{
       RCSTA.CREN = 1 ;
       if(RCIF_bit==1) c1=RCREG;
       DataReady1=0;
      // nettoye le buffer
      for(i1=0;i1<MAXLEN1-2;i1++)  buffer1[i1]=0;
      i1=0;
      Index1=0;
      c1=0;
      RCIE_bit = 1;
      p1=0;

}

void Arme_Timer1(unsigned int N)
 {
 //Prescaler 1:8; TMR1 Preload = 15536; Actual Interrupt Time : 100 ms
 // at 16Mhz
  T1CON         = 0x30; // avec TMR1ON_Bit=0
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
    T1GCON=0;
  Count1=N;
  Flag_Timer1=0;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=1;  //enable interrupt TMR1
    TMR1ON_bit=1;
}


char  DS18B20_Build_value(unsigned int temp2write, char * T)
 {
 const unsigned int RES_SHIFT =4;  //  economie de 1 byte  en supprimant  TEMP_RESOLUTION (- 8);
  unsigned char temp_whole;
  unsigned int temp_fraction;
  char Signe=0;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1  ;
      *(T) = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Signe=0;
    *(T) = '+';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
  *(T+1) = (temp_whole/10)%10 + 48;             // Extract tens digit
  if (*(T+1)=='0') *(T+1)=' ';
  *(T+2)=  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
  *(T+3)='.';
  // Convert temp_fraction to characters
  *(T+4) =  temp_fraction/1000    + 48;         // Extract thousands digit
  *(T+5) = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
  //*(T+6) =' ';// (temp_fraction/10)%10  + 48;         // Extract tens digit
  //*(T+7)= ' '; //temp_fraction%10      + 48;         // Extract ones digit
 // *(T+8)=0;
 // Ltrim(*(T+1));
 /*
 if (Signe==1)
  DS18B20_Temp1= ( temp_whole *1000) +temp_fraction  ;
  else
   DS18B20_Temp1= -(( temp_whole *1000) +temp_fraction  );
   */
   return Signe  ;
 }
 


void main()
{
   // voir page 61
  // 0=4xPLL OFF, 1111=IOFS=16Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  OSCCON=0b01111010;    //16Mhz
   // 0=4xPLL OFF, 1101=IOFS= 8Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // OSCCON=0b01110010;   //8Mhz
  // 0=4xPLL OFF, 1011=IOFS= 1Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // OSCCON=0b01011010;   //1Mhz
  // 0=4xPLL OFF, 0011=IOFS= 500Khz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  //  OSCCON=0b00011010;  //500khz

  WDTCON =0b00011010;
  Delay_ms(500);
      // RA5 as input for RX , RA4 as output for TX , RA2 as input
  TRISA=0b10000100;      // RA0 et RA4 en sorties
  ANSELA=0;             // no analog
  WPUA=0b00110000;      // weak pull up on RX & TX
  CM1CON0=0;       // disable comparators
  CM1CON1=0;
  CCP1CON=0;       // indispensable pour UART sur RA0
  
   // RA4=TX RA5=RX   (voir page 111 )

  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  APFCON.RXDTSEL=1;   // RX sur RA5
  APFCON.TXCKSEL=1;   // TX sur RA4
    // RA5 as input for RX , RA4 as output for TX
 // TRISA=0b10100100;      // RA0,RA1 en sortie      RA2 en entree
 // PORTA=0xFF;

  TX3_Pin_Dir=0;
  GT38_Set_Pin_Dir=0;   // RA1
  GT38_Set_Pin=1;
  TX3_Pin=0;

  FVRCON.FVREN=0;       //disable  voltage reference     (voir page 124)
  FVRCON.TSEN=0;        // temperature enable=0;
  FVRCON.CDAFVR1=0;     // Comparator & DAC OFF
  ADCON0=0;
  ADCON1=0x01;
  
    // RA5 input RX , RA4 output TX, RA2 = OWS input
   c3=0;
   RS_Count=0;
   RS_tmp =0;
   RS_Delay=0;
   CRLF3();
   


   txt=&TEXTE[0];
   UART1_Init(9600);
  // UART1_Init(UART1_BAUDS);
   // IMPORTANT :
    // re-init AGAIN TRISA apres init UART  , because Uart init disturbing
   TRISA=0b11000100;      // RA0,RA1,  en sortie



   // 2 times to get empty fifo !
   if (PIR1.RCIF==1) c1 = RCREG;     // vide Fifo
   DataReady1=0;
   Index1=0;



// test Ok
/*
  UART3_Write_CText(" OSCSTAT = ");
   ByteToStr(OSCSTAT,txt);
   UART3_Write_Text(txt);
   UART3_Write(TAB);
   ByteToHex(OSCSTAT,txt);
   UART3_Write_Text(txt);
   CRLF3();
   if ((OSCSTAT.HFIOFL==1) && (OSCSTAT.HFIOFS==1))
   {
   UART3_Write_CText(" Osc stable ..OK \n\r");
   }
   */
   CRLF3();

   // presentation
   for (i=1;i<10;i++)
   {
   UART3_Write_CText(Messages[i]);
   Delay_ms(100);
   }
    CRLF3();
   Count=0;
   CptErr=0;
   c1=0;
   NB=64;
   txt  =&TEXTE[0];

     UART3_Write_CText(" Test reg. DS18B20\r\n");
     Delay_ms(100);
     j=0;
     Ow_Reset(OWS_Pin);       // Onewire reset signal
      Delay_us(250);
     Ow_Write(OWS_Pin, 0x33); // Read ROM (if only one device)
      Delay_us(250);
     c1=Ow_Read(OWS_Pin); //  123456789012345678901234567890123456789012345678
        Delay_us(250);
     UART3_Write_CText(" Family Code: ");
      txt=&TEXTE[0];
      *(txt)=0;
     ByteToHex(c1,txt);
     UART3_Write_Text(txt);
     //Data: Family Code ID1= FF4715811603 CRC= 24
     UART3_Write_CText(" ID1= ");
     for (i=0;i<6;i++)
     {
     c1=  Ow_Read(OWS_Pin);
      Delay_us(250);
    // ID1[i]=c1;
     *(txt)=0;
     ByteToHex(c1,txt);
     UART3_Write_Text(txt);
     }
    /*
     UART3_Write_CText("  CRC= ");
     c1=  Ow_Read(OWS_Pin); // CRC
      *(txt)=0;
     ByteToHex(c1,txt);
     UART3_Write_Text(txt);
     */
     CRLF3();

     RCSTA=0;
     RCSTA.CREN=1;  //enable receiver
     RCSTA.SPEN=1;  // serial port Pins Enable
     RCSTA.SREN=1;  // single bit receive
     c1 = RCREG;   // RAZ errors

     INTCON=0;
     OPTION_REG=0;  // concerne Timer0 et RA2 int

     UART3_Write_CText(" Init GT38 (Rose)sur Canal " GT38_CANAL" mode: "GT38_MODE" Bauds:"GT38_BAUDS" Puiss:" GT38_PUISSANCE"\r\n");
     UART3_Write_CText(" et Lecture config \r\n");
     CRLF3();
     Delay_ms(100);

   //UART3_Write_CText(" IT UART RA4-RA5 & Timer1\r\n");
   //CRLF3();

   //RCIE_bit=1;
  // PEIE_bit=1;  // autorise IT des peripherique voir fig  8.1 p 77
  // GIE_bit=1;   // Enable all interrupts (timer1 & UART)
   

  
  /* 
    UART3_Write_CText(" teste Pause 5 sec Timer1 \r\n");
    Arme_Timer1(50);  // 5 sec
    UART3_Write_Text("start\r\n");
    while (Flag_Timer1==0) ;
    UART3_Write_Text("stop\r\n");
     */
  //   (16:47:41.704)  teste Pause 5 sec Timer1
  //   (16:47:41.704) start
  //   (16:47:46.702) stop


  
 /* Test UART1 comm
    NB=0;
     do
     {
     Raz_Buffer1();
     Arme_Timer1(20);  // 2 sec
      CRLF3();
     UART3_Write_CText(" Test COM UART PIC\r\n");
     while ((Flag_Timer1==0)&& (DataReady1==0));
     if (DataReady1==1) 
     {
     UART3_Write_CText(" reu :\r\n");
     UART3_Write_Text(buffer1);
     CRLF3();
      }
      NB++;
      }
      while(NB<5);
   */
    GT38_Set_Pin=0;
    Delay_ms(300);
    UART3_Write_CText(" Autorise IT UART1 RA5(RX) \r\n");
    TMR1IE_bit=0;
    PEIE_bit=1;  // autorise IT des peripherique voir fig  8.1 p 77
     GIE_bit=1;   // Enable all interrupts (timer1 & UART)

     NB=12;
     UART3_Write_CText("Config GT38: \r\n");
     UART3_Write_CText("AT\r\n");
     Raz_Buffer1();
     UART1_Write_CText("AT\r\n");
     Delay_1sec();
     if(DataReady1==1)
      {
     UART3_Write_CText(" reu :\r\n");
     UART3_Write_Text(buffer1);
     CRLF3();
      }

    UART3_Write_CText("AT+V\r\n");
     Raz_Buffer1();
     UART1_Write_CText("AT+V\r\n");
    Delay_1sec();
     if(DataReady1==1)
      {
     UART3_Write_CText(" reu : ");
     UART3_Write_Text(buffer1);
     CRLF3();
      }
    
      UART3_Write_CText("AT+"GT38_MODE"\r\n");
    Raz_Buffer1();
     UART1_Write_CText("AT+"GT38_MODE"\r\n");
     Delay_1sec();
      if(DataReady1==1)
      {
     UART3_Write_CText(" reu : ");
     UART3_Write_Text(buffer1);
     CRLF3();
      }
      
    UART3_Write_CText("AT+C"GT38_CANAL"\r\n");
    Raz_Buffer1();
    UART1_Write_CText("AT+C"GT38_CANAL"\r\n");
     Delay_1sec();
    if(DataReady1==1)
      {
     UART3_Write_CText(" reu :");
     UART3_Write_Text(buffer1);
     CRLF3();
      }
      
     UART3_Write_CText("AT+B"GT38_BAUDS"\r\n");
     Raz_Buffer1();
    UART1_Write_CText("AT+B"GT38_BAUDS"\r\n");
     Delay_1sec();
    if(DataReady1==1)
    {
     UART3_Write_CText(" reu :");
     UART3_Write_Text(buffer1);
     CRLF3();
      }
     
    UART3_Write_CText("AT+"GT38_PUISSANCE"\r\n");
    Raz_Buffer1();

    UART1_Write_CText("AT+"GT38_PUISSANCE"\r\n");
     Delay_1sec();
      if(DataReady1==1)
      {
     UART3_Write_CText(" reu :\r\n");
     UART3_Write_Text(buffer1);
     CRLF3();
      }
    
    UART3_Write_CText("AT+RX\r\n");
    Raz_Buffer1();

     UART1_Write_CText("AT+RX\r\n");
      Delay_1sec();
    if(DataReady1==1)
      {
     UART3_Write_CText(" reu :\r\n");
     UART3_Write_Text(buffer1);
     CRLF3();
      }


  j=0;
  k=0;
   txt=&TEXTE[0];
  *(txt)=0;
  Mode_Sleep=0;
  NB=16;
  UART3_Write_CText(" GT38 mode normal SET pin=1\r\n");
  GT38_Set_Pin=1;   //normal
   
  while(1)
  {
     j++;


       //---------------------------
         Ow_Reset(OWS_Pin);              // Onewire reset signal
         Delay_us(50);
         Ow_Write(OWS_Pin, 0xCC);       // Issue command SKIP_ROM
         Delay_us(50);
         Ow_Write(OWS_Pin, 0x44);       // Issue command CONVERT_T
         Delay_us(250);
         Ow_Reset(OWS_Pin);
         Ow_Write(OWS_Pin, 0xCC);      // Issue command SKIP_ROM
         Ow_Write(OWS_Pin, 0xBE);     // Issue command READ_SCRATCHPAD    for only one sensor
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
         temp =  Ow_Read(OWS_Pin);
         temp = (Ow_Read(OWS_Pin) << 8) + temp;
          //--- Format and display result
          WordToStr(j,CRam1);
          UART3_Write_Text(CRam1);   UART3_Write(';');
          for (i=0;i<32;i++) TEXTE[i]=0;
          txt=&TEXTE[0];
          strConstRamCpy(txt,"TEx=+19.99C\r\n");
          cx= DS18B20_Build_value(temp,txt+4) ;
          UART3_Write_Text(txt) ;
      
       // strConstRamCpy(CRam1,"Mes1?");
       if(DataReady1==1)
       {   
           //   p1=strstr(buffer1,CRam1);
           p1=strstr(buffer1,"Mes1?");
           UART3_Write_Text(buffer1);
           CRLF3();
           Delay_ms(50);
          if (p1>0)
          {

               UART1_Write_Text(txt);
              CRLF1();
                p1=0;
           }
         DataReady1=0;
       } //if dataready
       else
       UART1_Write_Text(txt) ;
       Raz_Buffer1();
       for (i=0;i<3;i++) Delay_1sec();
   } // fin de boucle  while (1)
 }

/*

 Compilateur : MikroC 7.6.0<LF><CR> Directory :C:\_MikroC\_MesProjets_MikroC\_12F1840_GT38_test_Transceivers_2022_07
 Projet    :_12F1840_GT38_test_Transceivers_2022_07.mcppi
 Source    :_12F1840_GT38_test_Transceivers__2022_0726
 MCU  :12F1840 DIP8  Config: P12F1840_Fosc_Interne_16MHz.cfgsch
 POWER_SUPPLY: 3,6V  4.5V
 ATTENTION! Pin 1 =VDD pin 8=Gnd
 Capteur OWS DS18B20 sur RA2(pin5)
 GT38 SET sur RA1(pin6)
 GT38 modeFU3
 UART1 <-> GT38 9600,8,N,1  pin2=RA5=RX  Pin3=RA4=Tx
 Avec (only) TX UART3 19200 bds (en ASM !) sur RA0 (Pin 7) output

 Test registres DS18B20
 Family Code : 28 ID1= AA4265261302 IT UART RA4-RA5 & Timer1<LF><CR>
 Init GT38 (Rose)sur Canal 014 mode: FU3 Bauds:9600 Puiss:P1
 et Lecture config

Config GT38:
AT
GT38 Version
GT38 ModeFU3
AT+014
AT+9600
AT+P1
AT+RX
    1;TEx=+29.31C
    2;TEx=+29.31C
    3;TEx=+29.31C
    4;TEx=+29.50C
    5;TEx=+30.31C




*/