
#define Version "2024_11"         //29-11-2024
//_12F1840_GT38_test_Transceivers_2024_1127_avec relayRA0_OK- Copie.c.txt
// sans UART3 , mais sortie relay
#define With_GT38
 // usage de UART1 9600 -> GT38 
 // GT38 JAUNE avec antenne coax cot  PIC 12F1840 + DS18B20 OWS  + sortie LED RA0  (relay)
 
 // 
 /*  GT38  JAUNE  avec antenne coax cot Terminal  cot PC
   YAT configur  9600 bds
   Mettre commutateur SET=0 pour etre en  mode AT
   AT
   OK
   AT+V
   guoyunkeji?GT-38
    https://shop532831232.taobao.com
 
 AT+FU4
 OK+FU4
 ..le mode FU4 passe d'office la vitesse  1200 bauds
AT+RX
 OK+B1200
 OK+C016
 OK+RP:+20dBm
 OK+FU4
   puis SET=1
   -------------------------------------------
   
   GT38  BLEU disrtant configur par programme PIC12F1840
  AT
 OK
AT+V
 guoyunkeji GT-38
 https://shop532831232.taobao.com
AT+RX
 OK+B1200
 OK+C016
 OK+RP:+20dBm
 OK+FU4
 */

/*
   horloge  :  interne  16 MHz ... pas de quartz
   Librairies utilisees :
   - built_in.h
   - UART
   - C_String
   - Conversions
   - ADC

 */

  /* Hardware
  12F1840
  pin 1     VDD Alim +5V    --------- pin 1 GT38  VCC
  pin 2     RA5  input RX ---- <---- Pin 4  GT38 TX
  pin 3     RA4  output TX ---->---- Pin 3  GT38 RX
  pin 4     RA3/MCLR/VPP -- ICSP Reset
  pin 5     RA2  input <--- OWS DS18B20
  pin 6     RA1 Output --------------> Pin 5 GT38 SET input
  pin 6     RA1 ICSP Clock
  pin 7     RAO  ICSPDAT
  pin 7     RAO  Output   ----Led rouge ou relais de chauffage    (au lieu de UART3 soft
  pin 8     VSS alim 0V     -------- Pin 2 GT38 Gnd
  */
   //     ac:schema
   

#include "built_in.h"     // for  Hi  Lo ..etc
//#define With_UART3       //UART3 9600bds  pour traage programme
  
#define TAB 9
#define CLS 12
#define CR 13
#define LF 10

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_12F1840_GT38_test_Transceivers_2024_11"
#define Projet "_12F1840_GT38_test_Transceivers_2024_11.mcppi"
#define Source "_12F1840_GT38_test_Transceivers_"      // sans date ni  extension !
#define Langage "MikroC 7.6.0"
#define Config "P12F1840_Fosc_Interne_16MHz.cfgsch"
//CONFIG1 : $8007 : 0x0984
//CONFIG2 : $8008 : 0x3413

#define MCU "12F1840 DIP8"
#define POWER_SUPPLY "3,6V  4.5V"    // (3,3 to 4,2V battery Li-IOn)
#define OSCILLATEUR_INTERNE
#define FOSC "16MHZ"
#define EEPROM_FILE "xxx_Eeprom.ihex"

#define Print  Write_String

#define GT38_MODE_FU "FU4"
#define GT38_BAUDS "B1200"    // UART1  Hardware
#define GT38_PUISSANCE "P8"     // P8 + 20dbm
#define GT38_CANAL   "C016"

#define OWS_Pin  &PORTA,2
sbit GT38_Set_Pin at LATA.B1;
sbit GT38_Set_Pin_Dir at TRISA.B1;


#ifdef With_UART3
//************  UART 3 en ASM *******************
#define SPEED 56  // at 9600  104S/bit  at 16MHz
//#define SPEED 28    //  at 19200 52S / bit at 16Mhz
// la Pin de sortie UART est definie dans le main program
sbit TX3_Pin at LATA.B0;
sbit TX3_Pin_Dir at TRISA.B0;
unsigned char c3 absolute 0x0020;
unsigned char RS_Count absolute 0x0021;
unsigned char RS_tmp absolute   0x0022;
unsigned char RS_Delay absolute 0x0023;
#else
sbit Relay at LATA.B0;
sbit Relay_Dir at TRISA.B0;
#endif

//**********************************

const code char mesg0[]="                    "; // 20 blancs pour effacer la ligne LCD
const code char mesg1[]=" Compilateur : "Langage"\n\r";
const code char mesg2[]=" Directory :"Directory"\r\n";
const code char mesg3[]=" Projet    :"Projet"\r\n";
const code char mesg4[]=" Source    :"Source"_"Version"\r\n";
const code char mesg5[]=" MCU  :"MCU" , Config: "Config"\r\n";
const code char mesg6[]=" Alim.: "POWER_SUPPLY"\r\n ATTENTION! Pin 1 =VDD pin 8=Gnd\r\n";
const code char mesg7[]=" Capteur OWS DS18B20 sur RA2(pin5) \r\n GT38 SET sur RA1(pin6)\r\n";
const code char mesg8[]=" GT38 mode"GT38_MODE_FU"\r\n Canal : "GT38_CANAL"\r\n UART1 <-> GT38 "GT38_BAUDS",8,N,1 pin2=RA5=RX  Pin3=RA4=Tx\r\n";
//const code char mesg9[]=" Avec (only) TX UART3 19200 bds (en ASM !) sur RA0 (Pin 7) output\r\n";
#ifdef With_UART3
const code char mesg9[]=" Avec (only) TX UART3 9600 bds (ASM) sur RA0 (Pin 7)\r\n";
#else
const code char mesg9[]=" Avec sortie Relay sur RA0 (Pin 7), pas de UART3 !\r\n";
#endif
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7,mesg8,mesg9}; //,mesg9};

//const unsigned short TEMP_RESOLUTION = 12;

#define MAXLEN1 40
volatile char buffer1[MAXLEN1];
unsigned short error;
volatile unsigned int CptErr;
volatile unsigned int Count;
volatile int Flag_Timer1;
volatile int   DataReady1;      // drapeau Data recue;
volatile int NB;
volatile int Index1, i1;
volatile  unsigned char c1, cx;
volatile int j;
unsigned int i,k;
//unsigned M;
char *p1;
char TEXTE[40];//  ="12F1840_Usart_Interrupt_Timer1";
char *txt;
char CRam1[16];
unsigned int Mode_Sleep;
char Recu=0;

volatile unsigned int Count1;

unsigned int temp=0;
//unsigned long  DS18B20_Temp1=0L;
//unsigned char TH1,TL1,AL1;
//unsigned char ID1[6];

#ifdef With_UART3
void UART3_Write(unsigned char c1);         // ecrit 1 char
void UART3_Write_Text(unsigned char *T);    // ecrit un texte situ en RAM
void UART3_Write_CText(const char *txt3);    // ecrit un texte en dur (situ en ROM)
void CRLF3(void) ;
#endif

void strConstRamCpy(char *dest, const char *source);
void Write_String(char * texte);
void CRLF1(void);
void Tempo(unsigned long L);
void Arme_Timer1(unsigned int N);
char  DS18B20_Build_value(unsigned int temp2write, char * T);

#ifdef With_UART3
void UART3_Write_CText(const char *txt3)
 {
   while (*txt3)
     {
     UART3_Write(*txt3++);
   Delay_us(250);
     }
}

void UART3_Write_Text(unsigned char *T)    // at adress  0x002 taille 42 bytes
{ char cc;
  cc=*(T);
  while(cc>0)     // verif sur VBRAY en mode ASCII
   {

    UART3_Write(cc);   // c3 variable globale
    T++;
    cc=*(T);

   Delay_us(250);
   }
}

void CRLF3()
{
 UART3_Write(CR);
 UART3_Write(LF);
}


void UART3_Write(unsigned char cc)      // 16MHz 19200 ou 9600 bauds
{
    c3=~cc;    // complement du caractere !
    // avec TX3_PIN => RA2  18F26K22
        // avec TX3_PIN => RA0 12F1840
  _asm{
    RSsend2:
        movlw   8               ; 8 bits
        movwf   _RS_Count       ; compteur de bits envoyes
        bcf     TX3_Pin         ; was LATA,2    bit de start
        call    RSdelai2        ; tempo
       //   rrf        _c1,f    ; on recupere dans C le bit à envoyer
       //  syntaxe a revoir en fonction du PIC utilise  rrcf avec 18F87J50
       //                                                rrf avec PIC12F1840
    L00:
        rrf    _c3,1                ; on recupere dans C le bit a envoyer
        btfsc   STATUS,C        ; bit a envoyer = 1 ?
        goto    L10             ; oui
        bsf     TX3_Pin                        ; was LATA,2     sinon 0
        goto    L20             ; on continue sur la tempo
    L10:
        bcf     TX3_Pin                        ; was LATA,2  bit a 1
    L20:
        call    RSdelai2                ; tempo
        decfsz  _RS_Count,1     ; on decremente le compteur de bits envoyés
        goto    L00             ; on continue sur les bits suivants
        bsf     TX3_Pin         ; was  LATA,2 ; bit de stop
        call    RSdelai2        ; tempo pour bit de stop
         call    RSdelai2       ; tempo pour bit de stop
        goto    LA1

    RSdelai2:                 // 52 S par bit at 19200 bauds  104S at 9600 bds

         MOVLW SPEED ;  //  at 9600   104S
         MOVWF _RS_tmp ;
    RS00:
         NOP;                ; fait parti de la tempo!
         NOP;
         NOP;
         NOP;
        // NOP;
         DECFSZ _RS_tmp,F ;
         GOTO   RS00 ;
         NOP;
         NOP;
         NOP;
         RETURN ;

    LA1:    nop;
   }
 }
 #endif


void Interrupts() iv 0x0004 ics ICS_AUTO 
{
   if (  (RCIE_bit==1) &&  (PIR1.RCIF==1) )
   {
      c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
       CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      CptErr++;
      RCSTA.SPEN= 1 ;
       c1 = RCREG;
      }
      
      // timeout ou maxi buffer    OU   CR et au moins 2 caracteres
      if ((Flag_Timer1==1) || (i1>MAXLEN1-2) ||  (c1==13)  )
        {
           RCIE_bit=0 ; //interdit IT Reception UART
            buffer1[i1]=0;
              DataReady1=1;
            Index1=i1;
            Delay_ms(20);    // attent le LF
            c1=RCREG;      // lit le LF suivant le CR
            i1=0;
            c1=0;
            }
            else
            {
            buffer1[i1]=c1;
            Index1=i1;
            i1++;
         }
     // }
    }
      // timer 1
    if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {
      Count1--;
      // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     if (Count1<1)   // x 100mS
       {
        Count1=0;
        Flag_Timer1=1;
        TMR1IE_bit=0;
      }
      TMR1H         = 0x3C;
      TMR1L         = 0xB0;
      PIR1.TMR1IF=0;

   }


 }


void Write_String(char * texte)
{
while ((* texte)>0)
 {
  UART1_Write(* texte++);
 }
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source) {
  while(*source) *dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART_Write(CR);
 UART_Write(LF);
}

void UART1_Write_CText(const char *txt1) {
   while ((*txt1)>0)
      UART1_Write(*txt1++);

}

void Raz_Buffer1()
{
       RCSTA.CREN = 0 ;
      CptErr=0;
       if(RCIF_bit==1) c1=RCREG;
       DataReady1=0;
      // nettoye le buffer
      for(i1=0;i1<MAXLEN1-2;i1++)  buffer1[i1]=0;
      i1=0;
      Index1=0;
      c1=0;
      Flag_Timer1=0;
     //TMR1ON_bit=1;
       RCSTA.CREN = 1 ;
     RCIE_bit = 1;
      p1=0;

}

void Arme_Timer1(unsigned int N)
 {
 //Prescaler 1:8; TMR1 Preload = 15536; Actual Interrupt Time : 100 ms
 // at 16Mhz
  T1CON         = 0x30; // avec TMR1ON_Bit=0
  TMR1H         = 0x3C;
  TMR1L         = 0xB0;
    T1GCON=0;
  Count1=N;
  Flag_Timer1=0;
  PIR1.TMR1IF=0;     // Reset Timer1 Flag
  PIE1.TMR1IE=1;  //enable interrupt TMR1
    TMR1ON_bit=1;
}


char  DS18B20_Build_value(unsigned int temp2write, char * T)
 {
 const unsigned int RES_SHIFT =4;  //  economie de 1 byte  en supprimant  TEMP_RESOLUTION (- 8);
  unsigned char temp_whole;
  unsigned int temp_fraction;
  char Signe=0;
  // Check if temperature is negative
    // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1  ;
      *(T) = '-';
     temp2write = ~temp2write + 1;
     }
     else
     {
     Signe=0;
    *(T) = '+';
     }
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  // Convert temp_whole to characters
  *(T+1) = (temp_whole/10)%10 + 48;             // Extract tens digit
  if (*(T+1)=='0') *(T+1)=' ';
  *(T+2)=  temp_whole%10     + 48;             // Extract ones digit
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
  *(T+3)='.';
  // Convert temp_fraction to characters
  *(T+4) =  temp_fraction/1000    + 48;         // Extract thousands digit
  *(T+5) = (temp_fraction/100)%10 + 48;         // Extract hundreds digit
   return Signe  ;
 }
 


void main()
{
   // voir page 61
  // 0=4xPLL OFF, 1111=IOFS=16Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  OSCCON=0b01111010;    //16Mhz
   // 0=4xPLL OFF, 1101=IOFS= 8Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // OSCCON=0b01110010;   //8Mhz
  // 0=4xPLL OFF, 1011=IOFS= 1Mhz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  // OSCCON=0b01011010;   //1Mhz
  // 0=4xPLL OFF, 0011=IOFS= 500Khz  0=0  00=SCS=config via Conf1 word FOSC<2:0>
  //  OSCCON=0b00011010;  //500khz

  WDTCON =0b00011010;
  Delay_ms(500);
      // RA5 as input for RX , RA4 as output for TX , RA2 as input
  TRISA=0b10100100;      // RA0 et RA4 en sorties
  ANSELA=0;             // no analog
  WPUA=0b00110000;      // weak pull up on RX & TX
   WPUA=0b00110000;

   // RA4=TX RA5=RX   (voir page 111 )


    _asm NOP ;
   // RA4=TX RA5=RX   (voir page 111 )
  APFCON=0;
  APFCON.P1BSEL=1;    // pour deconnecter de RA0 mais connecte sur RA4 ???!!
  _asm NOP ;
  APFCON.RXDTSEL=1;   // RX sur
  _asm NOP ;
  APFCON.TXCKSEL=1;   // TX sur RA4
  _asm NOP ;
  Delay_ms(100);

   CM1CON0=0;       // disable comparators
  CM1CON1=0;
  CCP1CON=0;       // indispensable pour UART sur RA0
  
  
    // RA5 as input for RX , RA4 as output for TX
  TRISA=0b10101100;      // RA0,RA1 en sortie      RA2,R3,RA5 en entree
 // PORTA=0xFF;

  #ifdef With_UART3
  TX3_Pin_Dir=0;
  TX3_Pin=0;
   c3=0;
   RS_Count=0;
   RS_tmp =0;
   RS_Delay=10;
  #else
  Relay_Dir=0;
  Relay=0;
   #endif
  GT38_Set_Pin_Dir=0;   // RA1
  GT38_Set_Pin=1;

  FVRCON.FVREN=0;       //disable  voltage reference     (voir page 124)
  FVRCON.TSEN=0;        // temperature enable=0;
  FVRCON.CDAFVR1=0;     // Comparator & DAC OFF
  ADCON0=0;
  ADCON1=0x00;
  
  // RA5 input RX , RA4 output TX, RA2 = OWS input
   txt=&TEXTE[0];
   UART1_Init(9600);
   // IMPORTANT :
    // re-init AGAIN TRISA apres init UART  , because Uart init disturbing
   TRISA=0b11101100;      // RA0,RA1,  en sortie   RA2 en entree    RA5 en entree

   // 2 times to get empty fifo !
   if (PIR1.RCIF==1) c1 = RCREG;     // vide Fifo      
   if (PIR1.RCIF==1) c1 = RCREG;     // vide Fifo
   DataReady1=0;
   Index1=0;

     #ifdef With_UART3
      CRLF3();
   // presentation
   for (i=1;i<10;i++)
   {
   UART3_Write_CText(Messages[i]);
   Delay_ms(100);
   }
    CRLF3();
     #endif
     
   Count=0;
   CptErr=0;
   c1=0;
   NB=64;
   txt  =&TEXTE[0];

     RCSTA=0;
     RCSTA.CREN=1;  //enable receiver
     RCSTA.SPEN=1;  // serial port Pins Enable
     RCSTA.SREN=1;  // single bit receive
     c1 = RCREG;   // RAZ errors

     INTCON=0;
     OPTION_REG=0;  // concerne Timer0 et RA2 int

    GT38_Set_Pin=0;
    Delay_ms(300);
    TMR1IE_bit=1;
    RCIE_bit=1;
    INTCON.PEIE=1;  // autorise IT des peripherique voir fig  8.1 p 77
    INTCON.GIE=1;   // Enable all interrupts (timer1 & UART)

     NB=30;
     Arme_Timer1(20);  // 1 sec
     Raz_Buffer1();
     UART1_Write_CText("AT\r\n");
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
   //  Print(buffer1);
    
     Raz_Buffer1();
     Arme_Timer1(20);  // 2 sec
     UART1_Write_CText("AT+V\r\n");
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
   //  Print(buffer1);
     
     Raz_Buffer1();
     Arme_Timer1(20);  // 1 sec
     UART1_Write_CText("AT+"GT38_CANAL"\r\n");
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
    // Print(buffer1);
  
     Raz_Buffer1();
     Arme_Timer1(20);  // 2 sec
     UART1_Write_CText("AT+"GT38_MODE_FU"\r\n");
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
    // Print(buffer1);
     

     
  /*
     Raz_Buffer1();
     Arme_Timer1(20);  // 1 sec
     UART1_Write_CText("AT+"GT38_BAUDS"\r\n");
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
   //  Print(buffer1);
    

    
     Raz_Buffer1();
     Arme_Timer1(20);  // 1 sec
     UART1_Write_CText("AT+"GT38_PUISSANCE"\r\n") ;
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
   //  Print(buffer1);
  */
     Raz_Buffer1();
     Arme_Timer1(20); 
      UART1_Write_CText("AT\r\n");
        while(  (Flag_Timer1==0)  & (DataReady1==0)  );
  
     Raz_Buffer1();
     Arme_Timer1(20);  // 2 sec
     UART1_Write_CText("AT+RX\r\n");
     while(  (Flag_Timer1==0)  & (DataReady1==0)  );
   //  Print(buffer1);
          Delay_ms(100);
     GT38_Set_Pin=1;
     Delay_ms(100);
     DataReady1=0;
     RCIE_bit=0;
     Delay_1sec();
     j=0;
     Ow_Reset(OWS_Pin);       // Onewire reset signal
     Delay_us(250);
     Ow_Write(OWS_Pin, 0x33); // Read ROM (if only one device)
     Delay_us(250);
     c1=Ow_Read(OWS_Pin); //  123456789012345678901234567890123456789012345678
     Delay_us(250);
   //  UART3_Write_CText(" Family Code: ");
      txt=&TEXTE[0];
      *(txt)=0;
     ByteToHex(c1,txt);
     for (i=0;i<6;i++)
     {
     c1=  Ow_Read(OWS_Pin);
      Delay_us(250);
    // ID1[i]=c1;
     *(txt)=0;
     ByteToHex(c1,txt);
     }

  //********** Attention ********************
     RCSTA=0;
     RCSTA.CREN=0;  //enable receiver
       RCSTA.SPEN=0;
        RCIE_bit=0;
         c1 = RCREG;
  // remettre la vitesse desire       GT38_BAUDS  !
    UART1_Init(1200);
     RCSTA.CREN=1;  //enable receiver
     RCSTA.SPEN=1;  // serial port Pins Enable
     c1 = RCREG;   // RAZ errors

  //suite probleme RA0 :
    TRISA=0b10101100;

  j=0;
  k=0;
   txt=&TEXTE[0];
  *(txt)=0;
  Mode_Sleep=0;
  NB=32;
   RCIE_bit=1;
   
  while(1)
  {
     j++;
       //---------------------------
         Ow_Reset(OWS_Pin);              // Onewire reset signal
         Delay_us(50);
         Ow_Write(OWS_Pin, 0xCC);       // Issue command SKIP_ROM
         Delay_us(50);
         Ow_Write(OWS_Pin, 0x44);       // Issue command CONVERT_T
         Delay_us(250);
         Ow_Reset(OWS_Pin);
         Ow_Write(OWS_Pin, 0xCC);      // Issue command SKIP_ROM
         Ow_Write(OWS_Pin, 0xBE);     // Issue command READ_SCRATCHPAD    for only one sensor
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
         temp =  Ow_Read(OWS_Pin);
         temp = (Ow_Read(OWS_Pin) << 8) + temp;
         for (i=0;i<32;i++) TEXTE[i]=0;
       txt=&TEXTE[0];
       //--- Format and display result
       WordToStr(j, txt) ;
       #ifdef With_UART3
          UART3_Write_Text(CRam1);   UART3_Write(';');
       #endif
       k=strlen(txt);
       strConstRamCpy(txt+k,"; Text=+19.99C\r\n");
       cx= DS18B20_Build_value(temp,txt+k+7) ;
       #ifdef With_UART3
          UART3_Write_Text(txt) ;
       #endif
         UART1_Write_Text(txt) ;
       Raz_Buffer1();
        Arme_Timer1(20);     //2sec maxi
        while ((Flag_Timer1==0)&& (DataReady1==0));
       if(DataReady1==1)
       {
          #ifdef With_UART3
              UART3_Write_Text(buffer1) ;
          #else
          // Print(buffer1);
           p1=strstr(buffer1,"Relay=");
           if(p1>0)
           {
             if(*(buffer1+6)=='1')
             {
              UART1_Write_CText("Realy ON\r\n") ;
              Relay=0; 
              }
              else
              {
                  UART1_Write_CText("Realy OFF\r\n") ;
                  Relay=1;
              }
            }
            #endif
            p1=0;
            DataReady1=0;

       } //if dataready
       else
       {
         Delay_1sec();
         Delay_1sec();
       }



   } // fin de boucle  while (1)
 }

/*

  cot PIC12F1840
   (10:14:06.671)     3; Text=+18.25C
(10:14:10.861)     4; Text=+18.18C
(10:14:15.052)     5; Text=+18.18C
(10:14:19.243)     6; Text=+18.18C
(10:14:23.433)     7; Text=+18.18C
(10:14:27.623)     8; Text=+18.18C
(10:14:31.814)     9; Text=+18.18C
(10:14:36.004)    10; Text=+18.18C
(10:14:40.213)    11; Text=+18.18C
(10:14:44.403)    12; Text=+18.18C
(10:14:45.935) Realy OFF
(10:14:46.029)    13; Text=+18.18C
(10:14:50.218)    14; Text=+18.18C
(10:14:54.409)    15; Text=+18.18C
(10:14:58.600)    16; Text=+18.18C
(10:15:02.811)    17; Text=+18.18C
(10:15:07.022)    18; Text=+18.18C
(10:15:11.234)    19; Text=+18.18C
(10:15:12.532) Realy OFF
(10:15:12.628)    20; Text=+18.18C
(10:15:16.814)    21; Text=+18.18C
(10:15:21.005)    22; Text=+18.18C
(10:15:25.196)    23; Text=+18.18C
(10:15:26.493) Realy OFF
(10:15:26.597)    24; Text=+18.18C
(10:15:30.776)    25; Text=+18.12C

cot YAT
(10:14:07.388)     3; Text=+18.25C
(10:14:11.578)     4; Text=+18.18C
(10:14:15.769)     5; Text=+18.18C
(10:14:19.960)     6; Text=+18.18C
(10:14:24.149)     7; Text=+18.18C
(10:14:28.340)     8; Text=+18.18C
(10:14:32.531)     9; Text=+18.18C
(10:14:36.721)    10; Text=+18.18C
(10:14:39.291) Relay=0
(10:14:40.930)    11; Text=+18.18C
(10:14:45.120)    12; Text=+18.18C
(10:14:45.413) Relay=0
(10:14:46.800) Realy OFF
(10:14:46.800)    13; Text=+18.18C   14; Text=+18.18C
(10:14:55.126)    15; Text=+18.18C
(10:14:59.317)    16; Text=+18.18C
(10:15:00.515) Relay=1
(10:15:03.527)    17; Text=+18.18C
(10:15:05.640) Relay=1
(10:15:07.739)    18; Text=+18.18C
(10:15:09.882) Relay=1
(10:15:11.951)    19; Text=+18.18C
(10:15:12.010) Relay=1
(10:15:13.395) Realy OFF
(10:15:13.395)    20; Text=+18.18C   21; Text=+18.18C
(10:15:21.722)    22; Text=+18.18C
(10:15:25.913)    23; Text=+18.18C
(10:15:25.972) Relay=0
(10:15:27.358) Realy OFF
(10:15:27.358)    24; Text=+18.18C   25; Text=+18.12C










=========================================

  version AVEC UART3
     Terminal sur UART3 PIC12F1840
 Traage programme
 cot PIC et GT38 Jaune

(15:10:02.278)  Compilateur : MikroC 7.6.0<LF><CR> Directory :C:\_MikroC\_MesProjets_MikroC\_12F1840_GT38_test_Transceivers_2022_07
(15:10:02.601)  Projet    :_12F1840_GT38_test_Transceivers_2022_07.mcppi
(15:10:02.782)  Source    :_12F1840_GT38_test_Transceivers__2022_0728
(15:10:02.960)  MCU  :12F1840 DIP8 , Config: P12F1840_Fosc_Interne_16MHz.cfgsch
(15:10:03.150)  POWER_SUPPLY: 3,6V  4.5V
(15:10:03.211)  ATTENTION! Pin 1 =VDD pin 8=Gnd
(15:10:03.336)  Capteur OWS DS18B20 sur RA2(pin5)
(15:10:03.404)  GT38 SET sur RA1(pin6)
(15:10:03.522)  GT38 modeFU3
(15:10:03.579)  UART1 <-> GT38 9600,8,N,1  pin2=RA5=RX  Pin3=RA4=Tx
(15:10:03.717)  Avec (only) TX UART3 9600 bds (en ASM !) sur RA0 (Pin 7) output
(15:10:03.908)
(15:10:03.970)
(15:10:03.970)  Init GT38 (Rose)sur Canal 14 mode: FU3 Bauds:9600 Puiss:P1
(15:10:03.996)  et Lecture config
(15:10:04.025)
(15:10:04.428)  Autorise IT UART1 RA5(RX) et IT Timer1
(15:10:04.486)  test Pause 2 sec Timer1
(15:10:04.539)  start
(15:10:06.525)  stop
(15:10:06.586) Config GT38:
(15:10:06.656) AT
(15:10:08.659) >
(15:10:08.796) AT+V
(15:10:10.765) >
(15:10:10.909) AT+FU3
(15:10:11.884) >
(15:10:12.046) AT+C14
(15:10:12.988) AT+B9600
(15:10:14.006) >
(15:10:14.140) AT+P1
(15:10:15.124) >
(15:10:15.184) AT+RX
(15:10:18.132) >
(15:10:18.190)
(15:10:18.190)  GT38 mode normal SET pin=1
(15:10:18.190)
(15:10:19.179)  Test reg. DS18B20
(15:10:19.311)  Family Code: 28 ID1= AA6B96411401
(15:10:19.398)     1;TEx=++85.00C
(15:10:24.450)     2;TEx=++20.06C
(15:10:29.507)     3;TEx=++20.06C
(15:10:34.563)     4;TEx=++20.06C
(15:10:39.618)     5;TEx=++20.06C
(15:10:44.675)     6;TEx=++20.00C
(15:10:49.730)     7;TEx=++20.06C
(15:10:54.786)     8;TEx=++20.00C

sur GT38 distabt Bleu
(15:09:52.045) TEx=++85.00C
(15:10:22.860) TEx=++85.00C
(15:10:27.816) TEx=++20.06C
(15:10:32.873) TEx=++20.06C
(15:10:43.083) TEx=++20.06C
(15:10:48.041) TEx=++20.00C
(15:10:53.096) TEx=++20.06C


Rponse du GT38 Bleu
terminal sur RX PIC12F1840

(15:15:51.888)  OK
(15:15:53.924)  guoyunkeji GT-38
(15:15:53.924)  https://shop532831232.taobao.com
(15:15:56.050)  OK+FU3
(15:15:57.191)  OK+C14
(15:15:58.175)  OK+B9600
(15:15:59.286)  OK+P1
(15:16:00.268)  OK+B9600
(15:16:00.268)  OK+C014
(15:16:00.268)  OK+RP:-1dBm
(15:16:00.268)  OK+FU3
*/